import math
import numpy as np
import matplotlib.pyplot as plt
from matplotlib.widgets import Slider, Button, RadioButtons

fig, ax = plt.subplots()
plt.subplots_adjust(bottom=0.25)
fig.patch.set_facecolor('#E0E0E0')

# ===============================
# axes et légendes du graphique : 
# ===============================
ax.patch.set_facecolor('#525354')
ax.set(ylim=(0, 50), xlim=(0, 100))
ax.set_aspect('equal')                                          # pour avoir un repère orthonormé
ax.set_title("trajectoire du boulet en chute libre")            # Le titre du graphique
ax.set_xlabel("x (m)")                                          # La légende de l'axe des abscisses
ax.set_ylabel("y (m)")                                          # La légende de l'axe des ordonnées
ax.legend()
ax.grid(which='both')

# =============================================================================
# création des valeurs de t comprises entre 0 et 8s avec un intervalle de 0.1 s
# =============================================================================
t = np.arange(0.0, 8.0, 0.1)

# ================================
# conditions initiales sur h et v0
# ================================
# ETAPE élève n°1 : saisir ici la formule fixant la hauteur initiale
# ETAPE élève n°2 : saisir ici la formule fixant la vitesse initiale

# ==================================
# Fonctions pour le calcul de x et y
# # ================================== 
def Calcul_x(angle):
    alpha = math.radians(angle)                             # conversion de l'angle en radian
    # ETAPE élève n°3 : saisir ici la formule de calcul des valeurs de x(t)
    return x

def Calcul_y(angle):
    alpha = math.radians(angle)                             # conversion de l'angle en radian
    # ETAPE élève n°4 : saisir ici la formule de calcul des valeurs de y(t)
    return y

# ==================================================================
# Fonction mettant à jour le graphique après modification de l'angle
# ==================================================================
def Graphique(val): 
    alpha = changeAngle.val
    points.set_xdata(Calcul_x(alpha))
    points.set_ydata(Calcul_y(alpha))
    traj.set_xdata(Calcul_x(alpha))
    traj.set_ydata(Calcul_y(alpha))

# ==================
# Tracé du graphique
# ==================
traj, = plt.plot(Calcul_x(0),Calcul_y(0),'-',color='gray')      # trajectoire en ligne continue grise
points, = plt.plot(Calcul_x(0),Calcul_y(0),'o',color='gold')    # positions seprésentées par des ronds jaunes

# ==========================================================================================
# Le curseur pour modifier l'angle de tir appelle la fonction Graphique à chanque changement
# ==========================================================================================
curseurAngle  = plt.axes([0.25, 0.1, 0.65, 0.03], facecolor='lightgrey')
changeAngle = Slider(curseurAngle, 'angle de tir : ', 0, 90, valinit=0, valstep=.1)
changeAngle.on_changed(Graphique)


plt.get_current_fig_manager().window.state('zoomed')   # pour que les graphiques s'affichent en plein écran
plt.show()